MODULE TestDec;

  (*******************************************************************
    
    Module  TestDec     (Version 1.0)
    
      Copyright (c) 2008 by Andreas Fischlin and ETH Zurich
      
    Purpose   Test DEC and INC semantics
    
    Remarks   The following code is compilable within MacMETH
              but the constant definition 'four' (type LONGINT )
              may fail in many language implementations.
    
    
    Programming
    
      o Design and Implementation
        Andreas Fischlin         02/23/2008
        
      URLs: 
        <mailto:RAMSES@env.ethz.ch> 
        <http://www.sysecol.ethz.ch> 
        <http://www.sysecol.ethz.ch/SimSoftware/RAMSES> 
    
        
    Implementation and Revisions:
    ============================
    
    Author  Date        Description of change
    ------  ----        ---------------------
    AF      02/23/2008  First implementation
    
  *******************************************************************)
  
  VAR
    e: (red, blue, green); i: INTEGER; c: CARDINAL;
    li: LONGINT; lc: LONGCARD;
  CONST
    four = 4D;
  
BEGIN (* TestDec *)
  e := red; INC(e); 
  e := green; i := 2; DEC(e,i);
  c := 1; INC(e,c);
  lc := 1; INC(e,lc);
  DEC(e,four*lc);
END TestDec.
